/*
 * $Header: /cvs/CVS_LEBA/external/openmap/openmap/src/openmap/com/bbn/openmap/wms/OpenMapLayerAdapter.java,v 1.1 2006/03/21 10:27:54 tomrak Exp $
 *
 * Copyright 2001-2005 OBR Centrum Techniki Morskiej, All rights reserved.
 *
 */
package com.bbn.openmap.wms;

import com.bbn.openmap.Layer;

/**
 * @version $Header: /cvs/CVS_LEBA/external/openmap/openmap/src/openmap/com/bbn/openmap/wms/OpenMapLayerAdapter.java,v 1.1 2006/03/21 10:27:54 tomrak Exp $
 * @author pitek
 */
public class DefaultLayerAdapter implements IWmsLayer {

    //~ Static variables/initializers ----------------------------------------------------------------------------------

    private static final IWmsLayerStyle[] defaultStyle = new IWmsLayerStyle[1];

    static {
        defaultStyle[0] = new DefaultWmsLayerStyle("default", "Default style", null);
    }

    //~ Instance variables ---------------------------------------------------------------------------------------------

    protected final Layer layer;

    //~ Constructors ---------------------------------------------------------------------------------------------------

    /**
     * Creates a new instance of OpenMapLayerAdapter
     *
     * @param layer
     */
    public DefaultLayerAdapter(Layer layer) {
        this.layer = layer;
    }

    //~ Methods --------------------------------------------------------------------------------------------------------

    /**
     * @return
     */
    public boolean isQueryable() {
        return false;
    }

    /**
     * @return
     */
    public boolean isOpaque() {
        return false;
    }

    /**
     * @return
     */
    public boolean isNoSubsets() {
        return false;
    }

    /**
     * @return
     */
    public boolean isCascaded() {
        return false;
    }

    /**
     * @return
     */
    public String getTitle() {
        return layer.getName();
    }

    /**
     * @return
     */
    public IWmsLayerStyle[] getStyles() {
        return defaultStyle;
    }

    /**
     * @return
     */
    public String getName() {
        return layer.getPropertyPrefix();
    }

    /**
     * @return
     */
    public String getKeywordList() {
        return null;
    }

    /**
     * @return
     */
    public int getFixedWidth() {
        return 0;
    }

    /**
     * @return
     */
    public int getFixedHeight() {
        return 0;
    }

    /**
     * @return
     */
    public String getAbstract() {
        return layer.getName();
    }

    /**
     * @param name
     * @throws IllegalArgumentException
     */
    public void setStyle(String name) {
        if (!isStyleSupported(name)) {
            throw new IllegalArgumentException("Unsupported style " + name);
        }
    }

    /**
     * @param name
     * @return
     */
    public boolean isStyleSupported(String name) {
        for (IWmsLayerStyle style : getStyles()) {
            if (style.getName().equals(name)) {
                return true;
            }
        }
        return false;
    }

    /**
     */
    public void setDefaultStyle() {
        // DO NOTHING
    }
     
}
