// **********************************************************************
// <copyright>
//  BBN Technologies
//  10 Moulton Street
//  Cambridge, MA 02138
//  (617) 873-8000
// 
//  Copyright (C) BBNT Solutions LLC. All rights reserved.
// </copyright>
// **********************************************************************
// $Source: /cvs/CVS_LEBA/external/openmap/openmap/src/wmsservlet/WEB-INF/src/com/bbn/openmap/wmsservlet/OgcWmsServlet.java,v $
// $Revision: 1.1 $ $Date: 2006/03/21 10:30:53 $ $Author: tomrak $
// **********************************************************************
package com.bbn.openmap.wmsservlet;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.Properties;
import java.util.HashMap;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.bbn.openmap.PropertyHandler;
import com.bbn.openmap.wms.WmsRequestHandler;
import com.bbn.openmap.wms.WMSException;
import com.bbn.openmap.util.Debug;

/**
 *
 */
public class OgcWmsServlet extends HttpServlet {

    
    
    protected WmsRequestHandler wmsRequestHandler;
    
    
    /**
     * A do-nothing constructor - init does all the work.
     */
    public OgcWmsServlet() {
        super();
    }

    
    /**
     *
     */
    Properties parsePropertiesFromRequest( HttpServletRequest request ) {
        Properties props = new Properties();
        java.util.Enumeration keys = request.getParameterNames();
        while( keys.hasMoreElements() ) {
            String key = (String)keys.nextElement();
            String value = request.getParameter(key);
            if( value != null ) {
                props.put(key,value);
            }
        }
        return props;
    }
    

    /**
     *
     */
    public void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        Debug.message("wms","OgcWmsServlet.doGet");
        
        Properties properties = parsePropertiesFromRequest(request);
        HttpResponse httpResponse = new HttpResponse(response);
        wmsRequestHandler.handleRequest(properties,httpResponse);
    }

    
    /**
     *
     */
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        Debug.message("wms","OgcWmsServlet.init : ");
        
        String mapDefinition = config.getServletContext().getInitParameter("mapDefinition");
        if( mapDefinition == null ) {
            mapDefinition = "openmap.properties";
        }
            
        //it would be great if we could retrieve server port from cContext/Config
        String serverPortStr = config.getServletContext().getInitParameter("port");
        if( serverPortStr == null ) {
            throw new ServletException("Server port number is not specified");
        }
        int serverPort = Integer.parseInt(serverPortStr);
               
        //it would be great if we could retrieve server port from cContext/Config
        String servletPath = config.getServletContext().getInitParameter("path");
        if( servletPath == null ) {
            throw new ServletException("servlet path is not specified");
        }
        
        Debug.message("wms","Using map definition:"+ config.getServletContext().getInitParameter("mapDefinition"));
        try {
           PropertyHandler propHandler = new PropertyHandler(mapDefinition);
           try {
               wmsRequestHandler = new WmsRequestHandler(serverPort, servletPath, propHandler.getProperties());
               
           } catch (WMSException wmse) {  
               Debug.message("wms","MS: caught WMSException - \n" + wmse.getMessage());
           }  
           
        } catch( java.net.MalformedURLException me) {
            Debug.message("wms","MS: caught MalformedURLException - \n" + me.getMessage());
        } catch( java.io.IOException ioe) {
            Debug.message("wms","MS: caught IOException - \n" + ioe.getMessage());
        }
    }
    
    
}
